// OpenVideoFileDoc.cpp : implementation of the COpenVideoFileDoc class
//
#include "stdafx.h"

#include "MainFrm.h"
#include "OpenVideoFile.h"
#include "OpenVideoFileDoc.h"

#include "VideoManager.h"
#include "VideoThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


/********************************************************************************/
extern CToolBar   *mainToolBar;
extern CStatusBar *mainStatusBar;
/********************************************************************************/
IMPLEMENT_DYNCREATE(COpenVideoFileDoc, CDocument)	// COpenVideoFileDoc
/********************************************************************************/
BEGIN_MESSAGE_MAP(COpenVideoFileDoc, CDocument)
	ON_COMMAND(ID_FILE_OPENVIDEOFILE, OnOpenVideoFile)
END_MESSAGE_MAP()
/********************************************************************************/
COpenVideoFileDoc::COpenVideoFileDoc()	// COpenVideoFileDoc construction/destruction
{
	_videoThread  = NULL;
	_videoManager = NULL;

}
COpenVideoFileDoc::~COpenVideoFileDoc()
{
	SAFE_DELETE(_videoManager);
}
/********************************************************************************/
void COpenVideoFileDoc::Serialize(CArchive& ar)
{
	if(ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}
/********************************************************************************/
#ifdef _DEBUG	// Generated message map functions
void COpenVideoFileDoc::AssertValid() const { CDocument::AssertValid(); }
void COpenVideoFileDoc::Dump(CDumpContext& dc) const { CDocument::Dump(dc); }
#endif //_DEBUG
/********************************************************************************/

/************************************************************************************************/
void COpenVideoFileDoc::RefreshToolBar()
{
	if(mainToolBar)
		mainToolBar->OnUpdateCmdUI((CMainFrame*)(AfxGetApp()->GetMainWnd()), true);

	if(mainStatusBar)
		mainStatusBar->OnUpdateCmdUI((CMainFrame*)(AfxGetApp()->GetMainWnd()), true);
}
void COpenVideoFileDoc::RecalcLayout()
{
	CFrameWnd *frame = (CFrameWnd*)AfxGetApp()->m_pMainWnd;
	
	if(frame)
		frame->RecalcLayout(TRUE);
}
/************************************************************************************************/
void COpenVideoFileDoc::OnOpenVideoFile()
{
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Video File |*.avi"), AfxGetMainWnd());

	INT_PTR status = fileDlg.DoModal(); 

	if(status != IDOK)
		return;

	CString fileName = fileDlg.GetPathName();

	StopVideoThread();

	SAFE_DELETE(_videoManager);
	_videoManager = new CVideoManager();

	_videoManager->OpenVideoFile(fileName);
	StartVideoThread();
}
/********************************************************************************/
void COpenVideoFileDoc::StartVideoThread()
{
	if(_videoThread)
		return;

	_videoThread = AfxBeginThread(VideoFrameThread, this, THREAD_PRIORITY_NORMAL);
}
void COpenVideoFileDoc::StopVideoThread()
{
	if(!_videoThread || !_videoManager)
		return;

	_killNextFrame.ResetEvent();
	_killNextFrame.SetEvent();

	::WaitForSingleObject(_nextFrameEnd.m_hObject, INFINITE); 

	_videoThread = NULL;
}
/********************************************************************************/