#pragma once

#import "SGSVideoSource.tlb" no_namespace, named_guids

class CVideoManager
{
public:
	CVideoManager(void);
	~CVideoManager(void);

	bool OpenVideoFile(CString &fileName);
	bool StopVideoStream();

	int NextFrame();

	bool IsVideoStraemOpen() { return _isVideoStreamOpen; }

	BITMAPINFO *GetColorHeader(){ return _colorHeader; }
	BITMAPINFO *GetGrayHeader() { return _grayHeader;  }
	UCHAR *GetColorData()       { return _colorImageData; }
	UCHAR *GetGrayData()        { return _grayImageData;  }
    CString GetVideoFileName()  { return _videoFileName;  }

	CSize GetColorImageSize(){ return CSize(_colorImageSize.width, _colorImageSize.height); }
	CSize GetGrayImageSize() { return CSize(_grayImageSize.width, _grayImageSize.height);   }

private:
	IVideoModulePtr _videoModulePtr;

	bool _isVideoStreamOpen;
	int  _videoStatus;

	VideoImageSize _colorImageSize, _grayImageSize;
	BITMAPINFO *_colorHeader, *_grayHeader;
	UCHAR *_colorImageData, *_grayImageData;

	CString _videoFileName;
};